
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>The fundamentals of web proxy caching with Varnish &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Starting Varnish" href="starting_varnish.html" />
    <link rel="prev" title="The Varnish Tutorial" href="index.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="starting_varnish.html" title="Starting Varnish"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="index.html" title="The Varnish Tutorial"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Varnish Tutorial</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The fundamentals of web proxy caching with Varnish</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="the-fundamentals-of-web-proxy-caching-with-varnish">
<span id="tutorial-intro"></span><h1>The fundamentals of web proxy caching with Varnish<a class="headerlink" href="#the-fundamentals-of-web-proxy-caching-with-varnish" title="Permalink to this headline">¶</a></h1>
<p>Varnish is a caching HTTP reverse proxy. It receives requests from clients
and tries to answer them from the cache. If Varnish cannot answer the
request from the cache it will forward the request to the backend,
fetch the response, store it in the cache and deliver it to the client.</p>
<p>When Varnish has a cached response ready it is typically delivered in a
matter of microseconds, two orders of magnitude faster than your typical
backend server, so you want to make sure to have Varnish answer as many
of the requests as possible directly from the cache.</p>
<p>Varnish decides whether it can store the content or not based on the
response it gets back from the backend. The backend can instruct Varnish
to cache the content with the HTTP response header <cite>Cache-Control</cite>. There
are a few conditions where Varnish will not cache, the most common one
being the use of cookies. Since cookies indicates a client-specific web
object, Varnish will by default not cache it.</p>
<p>This behaviour as most of Varnish functionality can be changed using
policies written in the Varnish Configuration Language (VCL). See
<a class="reference internal" href="../users-guide/index.html#users-guide-index"><span class="std std-ref">The Varnish Users Guide</span></a> for more information on how to do that.</p>
<section id="performance">
<h2>Performance<a class="headerlink" href="#performance" title="Permalink to this headline">¶</a></h2>
<p>Varnish has a modern architecture and is written with performance
in mind.  It is usually bound by the speed of the network, effectively
turning performance into a non-issue. You get to focus on how your web
applications work and you can allow yourself, to some degree, to care
less about performance and scalability.</p>
</section>
<section id="flexibility">
<h2>Flexibility<a class="headerlink" href="#flexibility" title="Permalink to this headline">¶</a></h2>
<p>One of the key features of Varnish Cache, in addition to its performance,
is the flexibility of its configuration language, VCL. VCL enables you
to write policies on how incoming requests should be handled.</p>
<p>In such a policy you can decide what content you want to serve, from
where you want to get the content and how the request or response should
be altered.</p>
</section>
</section>
<section id="supported-platforms">
<h1>Supported platforms<a class="headerlink" href="#supported-platforms" title="Permalink to this headline">¶</a></h1>
<p>Varnish is written to run on modern versions of Linux and FreeBSD and the
best experience is had on those platforms. Thanks to our contributors
it also runs on NetBSD, OpenBSD, OS X and various Solaris-descendants
like Oracle Solaris, OmniOS and SmartOS.</p>
</section>
<section id="about-the-varnish-development-process">
<h1>About the Varnish development process<a class="headerlink" href="#about-the-varnish-development-process" title="Permalink to this headline">¶</a></h1>
<p>Varnish is a community driven project. The development is overseen by
the Varnish Governing Board which currently consists of Poul-Henning Kamp
(Architect), Rogier Mulhuijzen (Fastly) and Lasse Karstensen (Varnish
Software).</p>
<p>Please see <a class="reference external" href="https://www.varnish-cache.org/trac/wiki/Contributing">https://www.varnish-cache.org/trac/wiki/Contributing</a> as a
starting point if you would like to contribute to Varnish.</p>
</section>
<section id="getting-in-touch">
<h1>Getting in touch<a class="headerlink" href="#getting-in-touch" title="Permalink to this headline">¶</a></h1>
<p>You can get in touch with us through many channels. For real time chat
you can reach us on IRC through the server irc.linpro.net on the #varnish
and #varnish-hacking channels.
There are two mailing lists available: one for user questions and one
for development discussions. See <a class="reference external" href="https://www.varnish-cache.org/lists">https://www.varnish-cache.org/lists</a>
for information and signup.  There is also a web forum on the same site.</p>
<p>Now that you have a vague idea on what Varnish Cache is, let’s see if we
can get it up and running.</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">The fundamentals of web proxy caching with Varnish</a><ul>
<li><a class="reference internal" href="#performance">Performance</a></li>
<li><a class="reference internal" href="#flexibility">Flexibility</a></li>
</ul>
</li>
<li><a class="reference internal" href="#supported-platforms">Supported platforms</a></li>
<li><a class="reference internal" href="#about-the-varnish-development-process">About the Varnish development process</a></li>
<li><a class="reference internal" href="#getting-in-touch">Getting in touch</a></li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="index.html"
                        title="previous chapter">The Varnish Tutorial</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="starting_varnish.html"
                        title="next chapter">Starting Varnish</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/tutorial/introduction.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="starting_varnish.html" title="Starting Varnish"
             >next</a> |</li>
        <li class="right" >
          <a href="index.html" title="The Varnish Tutorial"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Tutorial</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The fundamentals of web proxy caching with Varnish</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>